/*
gnaughty - porn movie downloader
Copyright (C) 2002 David Moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <curl/curl.h>
#include "callbacks.h"
#include "gui.h"
#include "gnaughty.h"
#include "urls.h"
#include "http.h"
#include "parselinks.h"
#include "prefs.h"

extern GladeXML* GnaughtyXML;
extern GnaughtyPrefs g_prefs;
extern gnaughty_config key;
extern gboolean keep_going;
gboolean updated_prefs;
extern GList *alllinks[NUMPORNTYPES];
extern GThreadPool* g_threadpool;
extern GHashTable* hashinfo;

gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	if(widget == glade_xml_get_widget(GnaughtyXML, "gnaughty_mainwindow")) {
		keep_going = FALSE;
		curl_global_cleanup();
		gtk_main_quit();
		return FALSE;
	}/* else if(widget == glade_xml_get_widget(GnaughtyXML, "download_window")) {
		stopdl();
		return TRUE;
	} */else if(widget == glade_xml_get_widget(GnaughtyXML, "preferences_window")) {
		gtk_widget_hide_all(glade_xml_get_widget(GnaughtyXML, "preferences_window"));
		return TRUE;
	}
	return FALSE;
}

void changeporntype(GtkOptionMenu *menu, gpointer *data)
{
	gnaughty_gui_clear_movie_list(GnaughtyXML);
	if (gtk_notebook_get_current_page(GTK_NOTEBOOK(glade_xml_get_widget(GnaughtyXML, "notebook")))) {
		gtk_notebook_set_current_page(GTK_NOTEBOOK(glade_xml_get_widget(GnaughtyXML, "notebook")), 0);
	}
	gnaughty_fill_movie_list(gtk_option_menu_get_history(menu));
	return;
}

void maxdlspun (GtkSpinButton *spinner, gpointer *data)
{
	if(spinner==GTK_SPIN_BUTTON(glade_xml_get_widget(GnaughtyXML, "nr_downloads")))
	{
		g_prefs.nr_downloads=gtk_spin_button_get_value_as_int(spinner);
	}

	g_thread_pool_set_max_threads(g_threadpool, g_prefs.nr_downloads, NULL);

	gnaughty_prefs_set(&g_prefs, key);
	updated_prefs = TRUE;
	return;
}

void entrychanged(GtkEntry *entry, gpointer *data)
{
	if(entry==GTK_ENTRY(glade_xml_get_widget(GnaughtyXML, "playcommand")))
	{
		g_prefs.playcommand=g_strdup(gtk_entry_get_text(entry));
	}
	if(entry==GTK_ENTRY(glade_xml_get_widget(GnaughtyXML, "playpiccommand")))
	{
		g_prefs.playpiccommand=g_strdup(gtk_entry_get_text(entry));
	}
	gnaughty_prefs_set(&g_prefs, key);
	updated_prefs = TRUE;
	return;
}



void buttontoggled(GtkToggleButton *button, gpointer *data)
{
	if(button==GTK_TOGGLE_BUTTON(glade_xml_get_widget(GnaughtyXML, "playafterdl")))
	{
		g_prefs.playafterdl=gtk_toggle_button_get_active(button);
	}
	if(button==GTK_TOGGLE_BUTTON(glade_xml_get_widget(GnaughtyXML, "showafterdl")))
	{
		g_prefs.showafterdl=gtk_toggle_button_get_active(button);
	}
	if(button==GTK_TOGGLE_BUTTON(glade_xml_get_widget(GnaughtyXML, "deleteafterplay")))
	{
		g_prefs.deleteafterplay=gtk_toggle_button_get_active(button);
	}
	#ifndef WIN32
	if(button==GTK_TOGGLE_BUTTON(glade_xml_get_widget(GnaughtyXML, "deleteinvalid")))
	{
		g_prefs.deleteinvalid=gtk_toggle_button_get_active(button);
	}
	#endif
	gnaughty_prefs_set(&g_prefs, key);
	updated_prefs = TRUE;
	return;
}

void choosesavedir(GtkButton *button, gpointer *data)
{
   GtkWidget *chooser;
   gchar *filename;
   
   chooser = gtk_file_chooser_dialog_new ("Select destination folder for downloaded files",NULL,
					  GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER,
					  GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
					  GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
					  NULL);

  gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (chooser), g_prefs.downloadpattern);

  if (gtk_dialog_run (GTK_DIALOG (chooser)) == GTK_RESPONSE_ACCEPT) {
    filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (chooser));
    g_free(g_prefs.downloadpattern);
    g_prefs.downloadpattern=g_strdup(filename);
    gtk_label_set_text(GTK_LABEL(glade_xml_get_widget(GnaughtyXML, "locationlabel")), g_prefs.downloadpattern);
    gnaughty_prefs_set(&g_prefs, key);
	updated_prefs = TRUE;
    g_free (filename);
  }

  gtk_widget_destroy (chooser);
}

typedef struct {
	download_t* download;
	gdouble status;
} download_progress_t;

gboolean set_download_progress(gpointer data)
{
	download_progress_t* args = (download_progress_t*)data;
	gnaughty_gui_set_download_progress(args->download, args->status);
	free(args);
	return FALSE;
}

int updateprogress(download_t* download, double t, double d, double ultotal, double ulnow)
{
	//this timimg thing has to be the most fucked-up hack I've ever seen
	//improvements would be welcome
	static double numbytes = 0;
	static time_t lastupdate = 0;
	static double lastspeed = 0;
	static double lasttotal = 0;
	double speed = 0;

	if (((time(0) - lastupdate) == 0) || lasttotal != t || numbytes > d)
		speed = lastspeed;
	else
		speed = ((d-numbytes)/1024)/(time(0) - lastupdate);

	//gtk_label_set_text(GTK_LABEL(glade_xml_get_widget(GnaughtyXML, "speed")), g_strdup_printf("%.0f/%.0f KB downloaded (%.1f K/s)", d/1024, t/1024, speed));
	//gtk_progress_set_value(GTK_PROGRESS(progress->bar), d*100.0/t);
	//gnaughty_gui_set_download_progress(download, d * 100.0 / t/*((double)progress->ThisMovie/progress->TotalMovies)+(d/t)*((double)1/progress->TotalMovies)*/);
	G_LOCK_DEFINE_STATIC(progressupdate);
	G_LOCK(progressupdate);
	download_progress_t* args = (download_progress_t*)malloc(sizeof(download_progress_t));
	args->download = download;
	if (t != 0)
		args->status = d * 100.0 / t;
	g_idle_add(set_download_progress, args);
	G_UNLOCK(progressupdate);
	//printf("Progress: %lf\n", d * 100.0 / t);
	if (keep_going == FALSE)
		return 1;

	numbytes = d;
	lasttotal = t;
	lastupdate = time(0);
	lastspeed = speed;
	return 0;
}

void refreshlist()
{
	gint porntype=gtk_option_menu_get_history(GTK_OPTION_MENU(glade_xml_get_widget(GnaughtyXML, "types_optionmenu")));
	
	gnaughty_gui_clear_movie_list();
	
	g_list_foreach(alllinks[porntype], (GFunc)gnaughty_link_free, NULL);
	g_list_free(alllinks[porntype]);
	alllinks[porntype]=NULL;

	gnaughty_fill_movie_list(porntype);
}

void show_prefs()
{
	gtk_widget_show_all(glade_xml_get_widget(GnaughtyXML, "preferences_window"));
	gnaughty_gui_prefs_window_set_prefs(&g_prefs);
}

void close_gnaughty()
{
	curl_global_cleanup();
	gnaughty_prefs_set(&g_prefs, key);
	gtk_main_quit();
	exit(0);
}

#ifndef WIN32
void update_prefs(gnaughty_config client, guint cnxn_id, GConfEntry *entry, gpointer user_data)
{
	if(!updated_prefs)
	{
		gnaughty_prefs_get(client);
		gnaughty_gui_prefs_window_set_prefs(&g_prefs);
	}
	else
		updated_prefs = FALSE;

	return;
}
#endif
void startdl()
{
	gtk_notebook_set_current_page(GTK_NOTEBOOK(glade_xml_get_widget(GnaughtyXML, "notebook")), 1);

	gnaughty_download_movies();
	return;
}

void stopdl()
{
	keep_going = FALSE;
	//gtk_widget_hide_all(glade_xml_get_widget(GnaughtyXML, "download_window"));
}

void clearsavedir(GtkButton *button, gpointer *data)
{
	gint response;
	const gchar *directory = gtk_label_get_text(GTK_LABEL(glade_xml_get_widget(GnaughtyXML, "locationlabel")));
	GtkWidget *dialog = gtk_message_dialog_new (GTK_WINDOW(glade_xml_get_widget(GnaughtyXML, "preferences_window")), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "Are you sure you want to remove %s ?", directory);
	gtk_widget_grab_focus(gtk_dialog_add_button(GTK_DIALOG(dialog), GTK_STOCK_CANCEL, GTK_RESPONSE_NO));
	gtk_dialog_add_button(GTK_DIALOG(dialog), GTK_STOCK_DELETE, GTK_RESPONSE_YES);
	response = gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);
	
	if(response==GTK_RESPONSE_YES)
	{
		char *quoted = g_shell_quote(directory);
		char *command = g_strdup_printf("rm -r %s", quoted);
		system(command);
		g_free(command);
		g_free(quoted);
	}
	
}

void process_open_folder(GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer data)
{
	gchar *url;
	gchar *dirname;
	gchar *localpath;
	gchar *dirlocalpath;
	const char *argv[20]; /* Shouldn't need more than 20 arguments */

	gtk_tree_model_get(model, iter, DOWNLOADS_URL_COLUMN, &url, -1);
	localpath = (gchar *) g_hash_table_lookup (hashinfo, url);
	dirname = g_path_get_dirname (localpath);
	dirlocalpath = g_strconcat ("file://", dirname, NULL);
	argv[0] = "nautilus";
	argv[1] = dirlocalpath;
	argv[2] = NULL;
	//gtk_show_uri (gtk_widget_get_screen(GTK_WIDGET (data)),dirlocalpath, GDK_CURRENT_TIME, NULL);
	//I'm not using gtk_show_uri here because, in my system, it launches nautilus-cd-burner for a folder path
	gdk_spawn_on_screen (gtk_widget_get_screen(GTK_WIDGET (data)),NULL,(char **)argv,NULL,
						 G_SPAWN_SEARCH_PATH | G_SPAWN_STDOUT_TO_DEV_NULL | G_SPAWN_STDERR_TO_DEV_NULL,
						 NULL,NULL,NULL,NULL);
	g_free (dirname);
	g_free (dirlocalpath);
}

void process_execute_file(GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer data)
{
	gchar *url;
	gchar *localpath;
	gchar *urilocalpath;
	GFile *file;

	gtk_tree_model_get(model, iter, DOWNLOADS_URL_COLUMN, &url, -1);
	localpath = (gchar *) g_hash_table_lookup (hashinfo, url);
	file = g_file_new_for_path (localpath);	
	urilocalpath = g_file_get_uri (file);
	gtk_show_uri (gtk_widget_get_screen(GTK_WIDGET (data)), urilocalpath, GDK_CURRENT_TIME, NULL);
	g_free (urilocalpath);
	g_object_unref (file);
}

void remove_finished_downloads(GtkWidget *menuitem, gpointer userdata)
{
	gnaughty_remove_finished_downloads();
}

void execute_downloaded_file(GtkWidget *menuitem, gpointer userdata)
{
	GtkTreeSelection *selection;

	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW(userdata));
	if (selection == NULL) {
		return;
	}
	gtk_tree_selection_selected_foreach (selection, process_execute_file, GTK_WIDGET (userdata));
}

void open_download_folder(GtkWidget *menuitem, gpointer userdata)
{
	GtkTreeSelection *selection;

	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW(userdata));
	if (selection == NULL) {
		return;
	}
	gtk_tree_selection_selected_foreach (selection, process_open_folder, GTK_WIDGET (userdata));
}

void show_downloads_popup_menu(GtkWidget* treeview, GdkEventButton* event, gpointer userdata)
{
	GtkWidget *menu, *menuitem;

	menu = gtk_menu_new();

	menuitem = gtk_image_menu_item_new_from_stock (GTK_STOCK_MEDIA_PLAY, NULL);
	g_signal_connect(menuitem, "activate", G_CALLBACK(execute_downloaded_file), treeview);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
	menuitem = gtk_image_menu_item_new_from_stock (GTK_STOCK_OPEN, NULL);
	gtk_menu_item_set_label (GTK_MENU_ITEM (menuitem), "Open folder");
	g_signal_connect(menuitem, "activate", G_CALLBACK(open_download_folder), treeview);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
	menuitem = gtk_separator_menu_item_new ();
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
	menuitem = gtk_image_menu_item_new_from_stock (GTK_STOCK_CLEAR, NULL);
	gtk_menu_item_set_label (GTK_MENU_ITEM (menuitem), "Clear finished downloads");
	g_signal_connect(menuitem, "activate", G_CALLBACK(remove_finished_downloads), treeview);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

	gtk_widget_show_all(menu);

	/* Note: event can be NULL here when called from view_onPopupMenu;
	 *  gdk_event_get_time() accepts a NULL argument */
	gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL,
			(event != NULL) ? event->button : 0,
			gdk_event_get_time((GdkEvent*)event));
}

gboolean show_download_popup(GtkWidget* treeview, gpointer userdata)
{
	show_downloads_popup_menu(treeview, NULL, userdata);
	return TRUE;
}

gboolean download_column_clicked(GtkWidget *treeview, GdkEventButton *event, gpointer userdata)
{
	if (event->type == GDK_BUTTON_PRESS  &&  event->button == 3) {
		GtkTreeSelection* selection;

		selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));

		if (gtk_tree_selection_count_selected_rows(selection)  <= 1) {
			GtkTreePath *path;

			/* Get tree path for row that was clicked */
			if (gtk_tree_view_get_path_at_pos(GTK_TREE_VIEW(treeview),
						event->x, event->y,
						&path, NULL, NULL, NULL))
			{
				gtk_tree_selection_unselect_all(selection);
				gtk_tree_selection_select_path(selection, path);
				gtk_tree_path_free(path);
			}
		}

		show_downloads_popup_menu(treeview, event, userdata);

		return TRUE; /* we handled this */
	} else if (event->type == GDK_2BUTTON_PRESS  &&  event->button == 1) {

		execute_downloaded_file(NULL, treeview);

		return TRUE; /* we handled this */
	}

	return FALSE;
}

gboolean links_column_clicked(GtkWidget *treeview, GdkEventButton *event, gpointer userdata)
{
	if (event->type == GDK_BUTTON_PRESS  &&  event->button == 1 && (event->state & GDK_SHIFT_MASK) == 0) {
		GtkTreeSelection* selection;
		GtkTreePath *path;
		gboolean selected;

		selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview));

		/* Get tree path for row that was clicked */
		if (gtk_tree_view_get_path_at_pos (GTK_TREE_VIEW(treeview),
					event->x, event->y, &path, NULL, NULL, NULL))
		{
			selected = gtk_tree_selection_path_is_selected (selection, path);

			if (selected) {
				gtk_tree_selection_unselect_path (selection, path);
			} else {
				gtk_tree_selection_select_path (selection, path);
			}

			gtk_tree_path_free (path);
		}

		return TRUE; /* we handled this */
	}

	return FALSE;
}

void on_prefs_ok_clicked(GtkButton *button, gpointer user_data)
{
	gtk_widget_hide_all(glade_xml_get_widget(GnaughtyXML, "preferences_window"));
}

void on_prefs_cancel_clicked(GtkButton *button, gpointer user_data)
{
	gtk_widget_hide_all(glade_xml_get_widget(GnaughtyXML, "preferences_window"));
}

// vim:noexpandtab:ts=4 sw=4:
