/*
gnaughty - porn movie downloader
Copyright (C) 2002 David Moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/
#ifndef GUI_H
#define GUI_H
#include <glade/glade.h>
#include <gtk/gtk.h>
#include "parselinks.h"
#include "prefs.h"

typedef struct {
	GtkWidget *list;
	GtkListStore *list_store;
} GnaughtyLinksListWidget;

typedef struct {
	GtkWidget *list;
	GtkListStore *list_store;
} GnaughtyDownloadsListWidget;

enum {
	LINKS_DESC_COLUMN,
	LINKS_URL_COLUMN,
	LINKS_N_COLUMNS
};

enum {
	DOWNLOADS_URL_COLUMN,
	DOWNLOADS_STATUS_COLUMN,
	DOWNLOADS_PROGRESS_COLUMN,
	DOWNLOADS_N_COLUMNS
};

GladeXML *gnaughty_gui_new_mainwin(gnaughty_config key);
GnaughtyLinksListWidget* create_links_list_widget();
GnaughtyDownloadsListWidget* create_downloads_list_widget();

void gnaughty_gui_set_download_progress(download_t* download, gdouble status);
gdouble gnaughty_gui_get_download_progress();
void gnaughty_gui_set_download_status(gchar* status);
void gnaughty_gui_set_download_filename(gchar *filename);
void gnaughty_gui_add_movie_list_item(link_t *item/*, GtkTreeIter *iter*/);
void gnaughty_gui_clear_movie_list();
GList *gnaughty_gui_get_selected_urls();
void gnaughty_gui_add_links_to_download_list(GList* downloads);
void gnaughty_gui_remove_download();

GnaughtyPrefs* gnaughty_gui_prefs_window_get_prefs();
void gnaughty_gui_prefs_window_set_prefs(GnaughtyPrefs *prefs);

gboolean gnaughty_gui_is_movies_selected();

#endif
// vim:noexpandtab:ts=4 sw=4:
