/*
gnaughty - porn movie downloader
Copyright (C) 2002 David Moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <curl/curl.h>
#include <curl/easy.h>
#include "http.h"
#include "callbacks.h"
#include "prefs.h"

extern GnaughtyPrefs g_prefs;

typedef struct {
	char *memory;
	size_t size;
} memory;

gboolean gnaughty_mkdir(const gchar *dirtomake)
{
	//maybe later i'll replace this with something fancy from make_path
	#ifndef WIN32
	GString *command=g_string_new("mkdir -p ");
	#else
	GString *command=g_string_new("mkdir ");
	#endif
	
	g_string_append(command, dirtomake);
	if(system(command->str)) {
		g_string_free (command, TRUE);
		return FALSE;
	}
	
	g_string_free (command, TRUE);
	return TRUE;
}

//shamelessly stolen from the libcurl examples
//http://curl.haxx.se/lxr/source/docs/examples/getinmemory.c
size_t write_mem(void *ptr, size_t size, size_t nmemb, void *data)
{
	register int realsize = size * nmemb;
	memory *mem = (memory *)data;
	
	mem->memory = (char *)realloc(mem->memory, mem->size + realsize + 1);
	if (mem->memory)
	{
		memcpy(&(mem->memory[mem->size]), ptr, realsize);
		mem->size += realsize;
		mem->memory[mem->size] = 0;
	}
	return realsize;
}

gint download(download_t* download, gchar* target)
{
	FILE *fp;
	gchar *referer;
	gchar *tmp1, *tmp2;
	CURL* curl_handle;
	GString *mpath;

	G_LOCK_DEFINE_STATIC(curlsetup);

	tmp1 = g_path_get_dirname(target);
	tmp2 = g_strdup_printf("\"%s\"", tmp1);
	if(!gnaughty_mkdir(tmp2))
	{
		puts("mkdir failed, skipping...");
		g_free (tmp1);
		g_free (tmp2);
		return 0;
	}
	g_free (tmp1);
	g_free (tmp2);	

	referer = g_strconcat("http://", download->URL->str, NULL);
	mpath = g_string_new (target);

	G_LOCK(curlsetup);
	while (g_file_test(mpath->str, G_FILE_TEST_EXISTS)) {
		g_string_insert_c (mpath, mpath->len - 4, '1');
	}
	if((fp=fopen(mpath->str, "wb")) == NULL)
	{
		perror("error");
		g_error("Error opening file: %s", mpath->str);
		g_string_free (mpath, TRUE);
		G_UNLOCK(curlsetup);
		exit(1);
	}
	g_string_free (mpath, TRUE);

	curl_handle = curl_easy_init();
	curl_easy_setopt(curl_handle, CURLOPT_URL, download->URL->str);
	curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, fwrite);
	curl_easy_setopt(curl_handle, CURLOPT_FILE, (void *)fp);
	curl_easy_setopt(curl_handle, CURLOPT_REFERER, referer);
	//let's fake a Mozilla UA, because everyone loves Mozilla
	curl_easy_setopt(curl_handle, CURLOPT_USERAGENT, "Mozilla/5.0 (X11; U; Linux i686; en; rv:1.9.1.9) Gecko/20100401 Firefox/3.5.9");
	curl_easy_setopt(curl_handle, CURLOPT_FOLLOWLOCATION, TRUE);
	if(download != NULL)
	{
		curl_easy_setopt(curl_handle, CURLOPT_NOPROGRESS, FALSE);
		curl_easy_setopt(curl_handle, CURLOPT_PROGRESSFUNCTION, updateprogress);
		curl_easy_setopt(curl_handle, CURLOPT_PROGRESSDATA, download);
	}
	if(g_prefs.useproxy)
	{
		curl_easy_setopt(curl_handle, CURLOPT_PROXY, g_prefs.proxyurl);
		curl_easy_setopt(curl_handle, CURLOPT_PROXYPORT, g_prefs.proxyport);
	}
	G_UNLOCK(curlsetup);
	curl_easy_perform(curl_handle);
	curl_easy_cleanup(curl_handle);

	g_free(referer);
	fclose(fp);
	return 1;
}

GString* getfile(const gchar *url, GString *final_url)
{
	GString *urlcontents;
	gchar *referer;
	const char* last_url;
	memory chunk;
	CURL* curl_handle;
	CURLcode cret;
	G_LOCK_DEFINE_STATIC(curlsetup);

	referer = g_strconcat("http://", url, NULL);

	G_LOCK(curlsetup);
	chunk.memory = NULL;
	chunk.size = 0;
	curl_handle = curl_easy_init();
	curl_easy_setopt(curl_handle, CURLOPT_URL, url);
	curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, write_mem);
	curl_easy_setopt(curl_handle, CURLOPT_FILE, (void *)&chunk);
	curl_easy_setopt(curl_handle, CURLOPT_NOPROGRESS, TRUE);
	curl_easy_setopt(curl_handle, CURLOPT_REFERER, referer);
	//let's fake a Mozilla UA, because everyone loves Mozilla
	curl_easy_setopt(curl_handle, CURLOPT_USERAGENT, "Mozilla/5.0 (X11; U; Linux i686; en; rv:1.9.1.9) Gecko/20100401 Firefox/3.5.9");
	curl_easy_setopt(curl_handle, CURLOPT_FOLLOWLOCATION, TRUE);
	if(g_prefs.useproxy==TRUE)
	{
		curl_easy_setopt(curl_handle, CURLOPT_PROXY, g_prefs.proxyurl);
		curl_easy_setopt(curl_handle, CURLOPT_PROXYPORT, g_prefs.proxyport);
	}
	G_UNLOCK(curlsetup);
	curl_easy_perform(curl_handle);
	cret = curl_easy_getinfo(curl_handle, CURLINFO_EFFECTIVE_URL, &last_url);
	if (cret == CURLE_OK) {
		g_string_printf (final_url, "%s", last_url);
		g_string_erase (final_url, 0, 7); //remove leading 'http://'
	} else {
		g_warning ("Error retrieving last used url: %s", curl_easy_strerror (cret));
		g_string_printf (final_url, "%s", url);
	}
	curl_easy_cleanup(curl_handle);

	urlcontents=g_string_new_len(chunk.memory, chunk.size);
	g_free(chunk.memory);
	g_free(referer);
	
	return urlcontents;
}
// vim:noexpandtab:ts=4 sw=4:
