/*
gnaughty - porn movie downloader
Copyright (C) 2002 David Moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/
#define _GNU_SOURCE
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <gtk/gtk.h>
#include "urls.h"

GString *gnaughty_urls_absolute_link(const gchar *urlstring, const gchar *base)
{
	gchar *temp;
	gchar *temp2;
	GString* newlink=g_string_new(NULL);
	if (strstr(urlstring, "http://") != urlstring)
	{
		if (urlstring[0] == '/') {
			temp = strchr (base, '/');
			if (temp != NULL) {
				temp2 = g_strndup (base, temp - base);
			} else {
				temp2 = g_strdup (base);
			}
			g_string_append(newlink, temp2);
			g_string_append(newlink, urlstring);
			g_free (temp2);
		} else {
			g_string_append(newlink, base);
			g_string_append(newlink, urlstring);
		}
	}
	else
	{
		g_string_append(newlink, urlstring);
		g_string_erase(newlink, 0, 7);
	}
	return newlink;
}

GString **gnaughty_urls_separate_link_hostname(const gchar *urlstring)
{
	gchar *divider=NULL;
	gchar *tmp = NULL;
	GString **parts;
	parts = g_malloc(sizeof(GString)*2);
	divider = strchr(urlstring, '/');
	if (divider == NULL) {
		puts("Invalid link");
		g_free(parts);
		exit(1);
	}
	tmp = g_strndup(urlstring, (unsigned long)divider-(unsigned long)urlstring);
	parts[0]=g_string_new(tmp);
	parts[1]=g_string_new(divider);
	g_free (tmp);
	return parts;
}

/**
 * Takes a url without the protocol parts and splits it into a host- and a filename part.
 * Returns an array of GStrings, with the first element set to the hostname and the
 * second element to the rest of the URL. If the urlstring argument cannot be split
 * correctly, NULL is returned.
 */
GString** gnaughty_urls_separate_link_filename(const gchar *urlstring)
{
	//printf("urlstring: %s\n", urlstring);
	gchar* divider = NULL;
	gchar* test = NULL;
	gchar* tmp = NULL;
	gchar* mistr = NULL;
	GString** parts;
	parts = g_malloc(sizeof(GString) * 2);
	divider = strrchr(urlstring, '/');
	test = strrchr(urlstring, '?');
	// If there's a '/' after a '?'
	if (divider != NULL && test != NULL && (strlen(test) > strlen(divider))) {
		//then try to find a '/' before '?' to set it as divider
		tmp = g_strrstr_len (urlstring, strlen(urlstring) - strlen(test) , "/");
		if (tmp != NULL) {
			divider = tmp;  //handle urls like www.wannawatch.com/hosted/index.php?wsc/sublimedir/bigtitpatrol98
		} else {
			divider = test; // or like www.wannawatch.com?wsc/sublimedir/bigtitpatrol98
		}
	}
	// Is it NULL? Might be a url in the form www.someserver.com?arg=something
	if (divider == NULL) {
		divider = strrchr(urlstring, '?');
	}

	// Still NULL? Then it's an invalid url.
	if (divider == NULL) {
		g_error("Invalid link");
		return NULL;
	} else {
		divider+=sizeof(gchar);
	}
	mistr = g_strndup(urlstring, (unsigned long)divider - (unsigned long)urlstring);
	parts[0] = g_string_new(mistr);
	parts[1] = g_string_new(divider);
	g_free (mistr);
	return parts;
}

void gnaughty_urls_free_pair(GString **data)
{
	g_string_free(data[0], TRUE);
	g_string_free(data[1], TRUE);
	g_free(data);
}
// vim:noexpandtab:ts=4 sw=4:
